#!/bin/bash

#
# Start script for the XUUDB admin client
#

#
# Installation Directory
#
dir=`dirname $0`
if [ "$dir" != "." ]
then
  INST=`dirname $dir`
else
  pwd | grep -e 'bin$' > /dev/null
  if [ $? = 0 ]
  then
    # we are in the bin directory
    INST=".."
  else
    # we are NOT in the bin directory
    INST=`dirname $dir`
  fi
fi

INST=${INST:-.}

cd $INST

#
# Read basic settings
#
. conf/startup.properties

#
# Options
#
#switch off confirmation message ("add" command)
OPTS="-Dxuudb.batch=true"

#set this one if you have ssl problems and need debug info
#OPTS=$OPTS" -Djavax.net.debug=ssl,handshake"

#
# Memory for the VM
#
MEM=-Xmx128m

#
# Put all jars in lib/ on the classpath
#
CLASSPATH=.$(find "$LIB" -name *.jar -exec printf ":{}" \;)
export CLASSPATH

DEFS="-Djava.util.logging.config.file=conf/client_logging.properties"
DEFS=$DEFS" -Dlog4j.configuration=conf/client_logging.properties"


# go
$JAVA ${MEM} ${OPTS} ${DEFS} de.fzj.unicore.xuudb.client.XUUDBClient "$@"

