/*
 * Copyright (c) 2012 ICM Uniwersytet Warszawski All rights reserved.
 * See LICENCE.txt file for licensing information.
 */ 
package de.fzj.unicore.xuudb.interfaces;

import javax.jws.WebMethod;

import de.fzJuelich.unicore.xuudb.GetAttributesRequestDocument;
import de.fzJuelich.unicore.xuudb.GetAttributesResponseDocument;
import de.fzJuelich.unicore.xuudb.SimulateGetAttributesRequestDocument;
import de.fzJuelich.unicore.xuudb.SimulateGetAttributesResponseDocument;

/**
 * XUUDB dynamic attributes query interface
 */
public interface IDynamicAttributesPublic {
	
	public static final String SERVICE_NAME="XUUDBDynamicAttributesQuery";

	/**
	 * Returns dynamic attributes for the entity described by the already established attributes
	 */
	@WebMethod()
	public GetAttributesResponseDocument getAttributes(GetAttributesRequestDocument xml);
	
	/**
	 * Performs a dry run of normal operation, checking to what a specified user would be mapped to.
	 * @return dynamic attributes 
	 */
	@WebMethod()
	public SimulateGetAttributesResponseDocument simulateGetAttributes(SimulateGetAttributesRequestDocument xml);
}
