package de.fzj.unicore.xuudb.server;

import java.io.FileInputStream;
import java.security.cert.X509Certificate;

import de.fzJuelich.unicore.xuudb.LoginDataType;
import eu.emi.security.authn.x509.impl.CertificateUtils;
import eu.emi.security.authn.x509.impl.CertificateUtils.Encoding;

public class TestMyBatisDNXUUDB extends TestMyBatisXUUDB {

	@Override
	protected boolean getMode(){
		return true;
	}
	
	public void testRemoveByDN()throws Exception{
		LoginDataType addRequest=getAddRequest("xlogin1:xlogin2:xlogin3");
		xuudb.add(addRequest);
		assertEquals(1, getEntries().length);
		
		//remove last one
		LoginDataType removeRequest=getRemoveByDNRequest();
		xuudb.remove(removeRequest);
		LoginDataType[]os=getEntries();
		assertEquals(0,os.length);
	}
	
	protected LoginDataType getRemoveByDNRequest()throws Exception{
		LoginDataType add=LoginDataType.Factory.newInstance();
		X509Certificate cert = CertificateUtils.loadCertificate(new FileInputStream("src/test/resources/demo-user.pem"), 
				Encoding.PEM);
		add.setToken(cert.getSubjectX500Principal().getName());
		return add;
	}
}
